<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransCancelReason ArrayType
 * @subpackage Arrays
 */
class ArrayOfTransCancelReason extends AbstractStructArrayBase
{
    /**
     * The TransCancelReason
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransCancelReason[]
     */
    public $TransCancelReason;
    /**
     * Constructor method for ArrayOfTransCancelReason
     * @uses ArrayOfTransCancelReason::setTransCancelReason()
     * @param \StructType\TransCancelReason[] $transCancelReason
     */
    public function __construct(array $transCancelReason = array())
    {
        $this
            ->setTransCancelReason($transCancelReason);
    }
    /**
     * Get TransCancelReason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransCancelReason[]|null
     */
    public function getTransCancelReason()
    {
        return isset($this->TransCancelReason) ? $this->TransCancelReason : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransCancelReason method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransCancelReason method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransCancelReasonForArrayConstraintsFromSetTransCancelReason(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransCancelReasonTransCancelReasonItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransCancelReasonTransCancelReasonItem instanceof \StructType\TransCancelReason) {
                $invalidValues[] = is_object($arrayOfTransCancelReasonTransCancelReasonItem) ? get_class($arrayOfTransCancelReasonTransCancelReasonItem) : sprintf('%s(%s)', gettype($arrayOfTransCancelReasonTransCancelReasonItem), var_export($arrayOfTransCancelReasonTransCancelReasonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransCancelReason property can only contain items of type \StructType\TransCancelReason, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransCancelReason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TransCancelReason[] $transCancelReason
     * @return \ArrayType\ArrayOfTransCancelReason
     */
    public function setTransCancelReason(array $transCancelReason = array())
    {
        // validation for constraint: array
        if ('' !== ($transCancelReasonArrayErrorMessage = self::validateTransCancelReasonForArrayConstraintsFromSetTransCancelReason($transCancelReason))) {
            throw new \InvalidArgumentException($transCancelReasonArrayErrorMessage, __LINE__);
        }
        if (is_null($transCancelReason) || (is_array($transCancelReason) && empty($transCancelReason))) {
            unset($this->TransCancelReason);
        } else {
            $this->TransCancelReason = $transCancelReason;
        }
        return $this;
    }
    /**
     * Add item to TransCancelReason value
     * @throws \InvalidArgumentException
     * @param \StructType\TransCancelReason $item
     * @return \ArrayType\ArrayOfTransCancelReason
     */
    public function addToTransCancelReason(\StructType\TransCancelReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransCancelReason) {
            throw new \InvalidArgumentException(sprintf('The TransCancelReason property can only contain items of type \StructType\TransCancelReason, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransCancelReason[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TransCancelReason|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TransCancelReason|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TransCancelReason|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TransCancelReason|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TransCancelReason|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransCancelReason
     */
    public function getAttributeName()
    {
        return 'TransCancelReason';
    }
}
